var app, header, footer, dialogBox, loading, actionSelector, photoBrowser, fourStageLinkage, UIAlbumBrowser;
apiready = function() {
    api.setStatusBarStyle({
        style: 'light',
        color: 'transparent' //设置APP状态栏透明色
    });
    header = $api.dom('header');
    footer = $api.dom('footer');
    if (header) {
        $api.fixStatusBar(header);
    }
    if (footer) {
        $api.fixTabBar(footer);
    }
    api.parseTapmode();
    loading = api.require('UILoading');
    initView();
    dialogBox = api.require('dialogBox');
    photoBrowser = api.require('photoBrowser');
    fourStageLinkage = api.require('fourStageLinkage');
    UIAlbumBrowser = api.require('UIAlbumBrowser');
}

/*--------------------------------api地址配置开始----------------------------*/
var API_HOST = 'https://api.hlbshop.com/'; //正式地址
// var API_HOST = 'https://api1.hlbshop.com/'; //测试地址
var URL = API_HOST + "api/"; //接口地址
//地址对象
var URLS = {
    "index": "index/index",
    "getAdminLoginLogs": "index/getAdminLoginLogs",
    "appWxLogin": "User/appWxLogin",
    "getShopInfo": "Shop/getShopInfo",
    "uploadOtherPicture": "Uploader/uploadOtherPicture",
    // 上传到阿里云oss方式
    "uploadOtherPicture2Oss": "Uploader/uploadOtherPicture2Oss",
    "getRegionList": "Region/getRegionList",
    "getMarketList": "Market/getMarketList",
    "setShopInfo": "Shop/setShopInfo",
    "getUserInfo": "User/getUserInfo",
    "uploadPrivatePicture": "Uploader/uploadPrivatePicture",
    // 认证
    "submitAuthentication": "Shop/submitAuthentication",
    "getAuthentication": "Shop/getAuthentication",
    "submitFeedback": "Feedback/submitFeedback",
    // 通知
    "getNoticeList": "Message/getNoticeList",
    "getNotice": "Message/getNotice",
    "readNotices": "Message/readNotices",
    // 删除通知
    "deleteNotices": "Message/deleteNotices",
    // 银行卡
    "getBankAccountList": "User/getBankAccountList",
    // 提现记录
    "getWithdrawalList": "User/getWithdrawalList",
    // 资金变动记录
    "getBalanceChangeList": "User/getBalanceChangeList",
    "getIntegralChangeList": "User/getIntegralChangeList",
    // 提现申请
    "submitWithdrawalApply": "User/submitWithdrawalApply",
    // 添加银行卡
    "addWithdrawalAccount": "User/addWithdrawalAccount",
    // 删除银行卡
    "deleteBankAccount": "User/deleteBankAccount",
    // 订单列表
    "getShopOrderList": "Order/getShopOrderList",
    // 订单详情
    "getOrder": "Order/getOrder",
    // 确认发货
    "doDelivery": "Order/doDelivery",
    // 物流列表
    "getExpressList": "Express/getExpressList",
    // 更新订单金额
    "updateOrderPrice": "Order/updateOrderPrice",
    // 删除订单
    "deleteOrder": "Order/deleteOrder",
    // 获取文章
    "getCommonArticle": "Article/getArticle",
    // 根据栏目获取文章列表
    "getArticlesByCategory": "Article/getArticlesByCategory",
    // 属性获取
    "getGoodsProperties": "Goods/getGoodsProperties",
    // 获取三级联动数据带选中项
    "getRegionListByDistrict": "Region/getRegionListByDistrict",
    // 获取指定属性的值
    "searchProperties": "Goods/searchProperties",
    //图片搜索
    "searchPictures": "Goods/searchPictures",
    // 商品图片上传
    "uploadGoodsPicture": "Uploader/uploadGoodsPicture",
    // 上传到oss接口
    "uploadGoodsPicture2Oss": "Uploader/uploadGoodsPicture2Oss",
    // 批量上传商品图片
    "batchUploadGoodsPicture": "Uploader/batchUploadGoodsPicture",
    // 上传到oss接口
    "batchUploadGoodsPicture2Oss": "Uploader/batchUploadGoodsPicture2Oss",
    // 批量上传其他图片
    "batchUploadOtherPicture": "Uploader/batchUploadOtherPicture",
    // 批量上传到oss
    "batchUploadOtherPicture2Oss": "Uploader/batchUploadOtherPicture2Oss",
    // 获取商品图片
    "getPictures": "Picture/getPictures",
    // 获取预览信息
    "getPreviewInfo": "Goods/getPreviewInfo",
    // 提交商品信息
    "submitAddGoods": "Goods/submitAddGoods",
    // 商品列表
    "getShopGoodsList": "Goods/getShopGoodsList",
    // 商品上下架
    "updateSaleStatus": "Goods/updateSaleStatus",
    //删除商品
    "deleteGoods": "Goods/deleteGoods",
    // 获取商品图片
    "getGoodsPictures": "Goods/getGoodsPictures",
    // 获取商品基础信息
    "getGoodsBaseInfo": "Goods/getGoodsBaseInfo",
    // 获取商品信息
    "getGoods": "Goods/getGoods",
    // 聊天列表
    "getChatList": "Message/getChatList",
    // 删除聊天列表
    "deleteChat": "Message/deleteChat",
    //设置消息已读
    "updateChatReadStatus": "Message/updateChatReadStatus",
    // 聊天消息列表
    "getChatMessageList": "Message/getChatMessageList",
    // 聊天语音文件上传
    "uploadImVoice": "Uploader/uploadImVoice",
    // 聊天图片文件上传
    "uploadImImage": "Uploader/uploadImImage",
    // 发布文章
    "submitArticle": "Bbs/submitArticle",
    // 论坛获取文章列表详情
    "getArticle": "Bbs/getArticle",
    // 论坛获取文章列表
    "getArticleList": "Bbs/getArticleList",
    // 获取我的文章列表
    "getMyArticleList": "Bbs/getMyArticleList",
    // 发表评论
    "submitComment": "Bbs/submitComment",
    // 获得评价列表
    "getCommentListByArticle": "Bbs/getCommentListByArticle",
    // 论坛获取通知列表
    "getCommentListByUser": "Bbs/getCommentListByUser",
    // 删除论坛文章
    "deleteArticle": "Bbs/deleteArticle",
    // 删除论坛文章评论
    "deleteArticleComment": "Bbs/deleteArticleComment",
    // 账号密码登录
    "doLogin": "User/doLogin",
    // 发送验证码
    "sendVerifyCode": "User/sendVerifyCode",
    // 手机验证码登录
    "mobileLogin": "User/mobileLogin",

    "updateUserInfo": "User/updateUserInfo",
    // 商品收藏列表
    "getGoodsCollectionList": "Collection/getGoodsCollectionList",
    // 店铺收藏列表
    "getShopCollectionList": "Collection/getShopCollectionList",
    // 新店铺认证
    "submitUnifyAuthentication": "Shop/submitUnifyAuthentication",
    // 更新店铺信息
    "updateShopInfo": "Shop/updateShopInfo",
    // 搜索商品
    "searchGoods": "Goods/searchGoods",
    // 搜索店铺
    "searchShop": "Goods/searchShop",
    // 获取投诉类型
    "getComplaintTypes": "Complaint/getComplaintTypes",
    // 提交投诉信息
    "submitComplaint": "Complaint/submitComplaint",
    // 获取产品互动信息
    "getGoodsInteractions": "Goods/getGoodsInteractions",
    // 发布互动消息
    "submitGoodsInteraction": "Goods/submitGoodsInteraction",
    // 店铺收藏或取消
    "doCollectionShop": "Collection/doCollectionShop",
    // 商品收藏
    "doCollectionGoods": "Collection/doCollectionGoods",
    // 首页顶级市场列表
    "getIndex": "Index/getIndex",
    // 首页二级市场列表
    "getIndexChildren": "Index/getIndexChildren",
    // 首页已有市场三级联动数据
    "getHadMarketRegionList": "Region/getHadMarketRegionList",
    // 商品搜索新方案
    "getConditionGoods": "Goods/getConditionGoods",
    // 店铺搜索新方案
    "getConditionShop": "Shop/getConditionShop",
    // 检测店铺收藏
    "checkShopIsCollected": "Collection/checkShopIsCollected",
    // 检测商品收藏
    "checkGoodsIsCollected": "Collection/checkGoodsIsCollected",
    // 更新商品点击数
    "updateGoodsClickNumber": "Goods/updateGoodsClickNumber",
    // 更新店铺点击数
    "updateShopClickNumber": "Shop/updateShopClickNumber",
    // 加载广告
    "getAdvertByPosition": "Advert/getAdvertByPosition",
    // 创建聊天关系
    "createChatRelation": "Message/createChatRelation",
    // 获取精确搜索结果
    "getAccurateList": "Goods/getAccurateList",
    // 重置密码
    "resetPassword": "User/resetPassword",
    // 店铺级别列表
    "getLevelList": "Shop/getLevelList",
    // 浏览记录
    "getViewLogs": "User/getViewLogs",
    // 清空历史记录
    "cleanViewLogs": "User/cleanViewLogs",
    // 验证码验证
    "checkVerifyCode": "User/checkVerifyCode",
    // 绑定第三方账号
    "bindConnects": "User/bindConnects",
    // 解绑第三方账户
    "unbindConnects": "User/unbindConnects",
    // 保存隐私设置
    "saveUserSetting": "User/saveUserSetting",
    // 获取隐私设置
    "getUserSetting": "User/getUserSetting",
    // 获取二维码
    "getQrcode": "Qrcode/getQrcode",
    // 店铺搜索[新]
    "searchShops": "Shop/searchShops",
    // 社区板块获取
    "getBlockList": "Block/getBlockList",
    // 社区文章获取[新版]
    "getArticleListByBlock": "Bbs/getArticleListByBlock",
    // 视频上传接口
    "uploadVideo": "Uploader/uploadVideo",
    // 视频上传到oss接口
    "uploadVideoToOss": "Uploader/uploadVideoToOss",
    // 动态发布接口
    "submitTimeline": "Timeline/submitTimeline",
    // 获取动态接口
    "getTimelines": "Timeline/getTimelines",
    // 点赞接口
    "timelineStar": "Timeline/timelineStar",
    // 评论接口
    "submitTimelineComment": "Timeline/submitTimelineComment",
    // 获取评论接口
    "getAllTimelineComments": "Timeline/getAllTimelineComments",
    // 获取用户动态接口
    "getUserTimelines": "Timeline/getUserTimelines",
    // 获取用户动态接口
    "getArticleListByUser": "Bbs/getArticleListByUser",
    // 获取用户简略信息
    "getInfoByUser": "User/getInfoByUser",
    // 删除朋友圈
    "deleteTimeline": "Timeline/deleteTimeline",
    // 删除朋友圈评论
    "deleteTimelineComment": "Timeline/deleteTimelineComment",
    // 首页推荐,精品和热门接口
    "getIndexRecommendList": "Index/getIndexRecommendList",
    // 系统设置获取接口
    "getSystemConfig": "System/getSystemConfig",
    // 更新检测接口
    "checkVersion": "Update/checkVersion",
    // 微信登录绑定手机号
    "wxLoginBindMobile": "User/wxLoginBindMobile",
    // 获取对话列表
    "getMessageItemList": "Im/getMessageItemList",
    // 获取好友列表
    "getFriendList": "Im/getFriendList",
    // 获取聊天消息记录
    "getMessageLogList": "Im/getMessageLogList",
    // 添加好友
    "addFriend": "Im/addFriend",
    // 删除好友
    "deleteFriend": "Im/deleteFriend",
    // 删除对话
    "deleteMessageItem": "Im/deleteMessageItem",
    // 设置消息为已读
    "setMessageReadStatus": "Im/setMessageReadStatus",
    // 检测是否为好友
    "checkIsFriend": "Im/checkIsFriend",
    // 获取好友请求列表
    "getAddFriendRequests": "Im/getAddFriendRequests",
    // 获取待处理好友请求列表
    "getUnCalcAddFriendRequestCount": "Im/getUnCalcAddFriendRequestCount",
    // 获取待处理好友请求列表
    "getUnreadMessageCount": "Im/getUnreadMessageCount",
    // 获取系统公告列表
    "getIndexDialogNotice": "Message/getIndexDialogNotice",
    // 获取公告模板列表
    "getNoticeTemplateList": "Template/getNoticeTemplateList",
    // 获取公告模板
    "getNoticeTemplate": "Template/getNoticeTemplate",
    // 保存生成记录
    "saveGenerateLog": "Template/saveGenerateLog",
    // 更改店铺状态
    "changeShopState": "Shop/changeShopState",
    // 更改店铺状态
    "updateGoodsState": "Goods/updateGoodsState",
    // 企业升级店铺认证提交接口
    "submitCompanyAuth": "Shop/submitCompanyAuth",
    // 屏蔽接口
    "join2Blocklist": "Timeline/join2Blocklist",
    // 移除黑名单
    "pop2Blocklist": "Timeline/pop2Blocklist",
    // 黑名单列表
    "getUserBlocklist": "Timeline/getUserBlocklist",
};

/*--------------------------------api地址配置结束----------------------------*/

// 事件广播
var eventName = {
    reloadBankCard: "reloadBankCard", //刷新银行卡事件
    reloadGoodsList: "reloadGoodsList", // 刷新商品列表
    addMessageItem: "addMessageItem", // 添加消息项
    sendMessage: "sendMessage", // 发送消息
    reloadChatList: "reloadChatList", // 刷新消息
    setChatReadStatus: "setChatReadStatus", // 设置消息是否有未读状态
    setNoticeReadStatus: "setNoticeReadStatus", // 设置通知是否有未读状态
    reloadMessageList: "reloadMessageList", // 刷新消息
    reloadOrder: "reloadOrder", //刷新订单
    reloadComment: "reloadComment", //刷新论坛
    reloadCommentDetail: "reloadCommentDetail", //刷新论坛
    reloadShop: "reloadShop", //刷新店铺
    refreshUserCenter: "refreshUserCenter", //刷新用户中心
    refreshCollectionGoods: "refreshCollectionGoods", //刷新商品收藏
    refreshCollectionShop: "refreshCollectionShop", //刷新店铺收藏
    reloadNoticeList: "reloadNoticeList", //刷新通知列表
    reloadTimelineList: "reloadTimelineList", //刷新动态列表
    reloadArticleList: "reloadArticleList", //刷新社区列表
    reloadShopList: "reloadShopList", //刷新店铺列表
    reloadFriendList: "reloadFriendList", //刷新好友列表
    reloadAddFriendList: "reloadAddFriendList", //刷新添加好友请求列表
    reloadAddFriendListCount: "reloadAddFriendListCount", //刷新添加好友请求数量
    loginEvent: "loginEvent", //登录事件
    logoutEvent: "logoutEvent", //登出事件
}


/*--------------------------------弹窗样式配置开始----------------------------*/
var confirmStyle = {
    bg: '#fff',
    w: 320,
    corner: 5,
    content: {
        marginT: 40,
        marginB: 40,
        color: '#000',
        size: 15
    },
    left: {
        marginB: 0,
        marginL: 0,
        w: 160,
        h: 50,
        corner: 5,
        bg: '#fff',
        color: '#000',
        size: 15
    },
    right: {
        marginB: 0,
        marginL: 0,
        w: 160,
        h: 50,
        corner: 5,
        bg: '#fff',
        color: '#E4393C',
        size: 15
    },
    horizontalLine: {
        color: '#dcdcdc',
        height: 1
    },
    verticalLine: {
        color: '#dcdcdc',
        width: 1
    }
}; //双按钮样式
var alertStyle = {
    bg: '#fff',
    w: 320,
    corner: 5,
    content: {
        marginT: 40,
        marginB: 40,
        color: '#000',
        size: 15
    },
    left: {
        marginB: 0,
        marginL: 0,
        w: 320,
        h: 50,
        corner: 5,
        bg: '#fff',
        color: '#000',
        size: 15
    },
    horizontalLine: {
        color: '#dcdcdc',
        height: 1
    },
}; //单按钮样式
// input样式
var inputStyle = {
        bg: '#fff', //（可选项）字符串类型；对话框整体背景配置，支持#、rgb、rgba、img；默认：#fff
        corner: 5, //（可选项）数字类型；对话框背景圆角大小；默认：2
        w: 300, //（可选项）数字类型；对话框的宽；默认：300
        h: 200, //（可选项）数字类型；对话框的高；默认：240
        title: { //（可选项）JSON 对象；弹窗的 title 样式配置，不传则不显示标题区域
            h: 40, //（可选项）数字类型；标题栏区域高度；默认：60
            marginT: 15, //（可选项）数字类型；标题栏与对话框顶端间距；默认：20
            alignment: 'center', //（可选项）字符串类型；标题文字显示位置；取值范围：center、left、right
            size: 15, //（可选项）数字类型；标题字体大小；默认：14
            color: '#000' //（可选项）字符串类型；标题字体颜色，支持#、rgb、rgba；默认：#000
        },
        input: { //（可选项）JSON 对象；输入框输入文本框样式配置
            h: 60, //（可选项）数字类型；输入框区域高度；默认：20
            alignment: 'center', //（可选项）字符串类型；输入框文字显示位置；取值范围：center、left、right
            marginT: 6, //（可选项）数字类型；输入框顶端与标题栏底端的距离，如果标题栏不存在，则是到窗口顶端的距离；默认：居中显示
            marginLeft: 10, //（可选项）数字类型；输入框的左边距；默认：10
            marginRight: 10, //（可选项）数字类型；输入框的右边距；默认：10
            textSize: 14, //（可选项）数字类型；输入文本框文本字体大小；默认：14
            textColor: '#000', //（可选项）字符串类型；输入文本框文本字体颜色，支持#、rgb、rgba；默认：#000
            borderColor: 'rgba(0,0,0,0)', //（可选项）字符串类型；输入文本框的边框颜色，支持#、rgb、rgba；默认：#000
            verticalCenter: true, //（可选项）布尔类型；是否上下居中；默认：false；该参数暂仅支持 android
            textColor: '#000', //（可选项）字符串类型；输入文本框文本字体颜色，支持#、rgb、rgba；默认：#000
            borderColor: 'rgba(0,0,0,0)', //（可选项）字符串类型；输入文本框的边框颜色，支持#、rgb、rgba；默认：#000
            borderWidth: 1 //（可选项）数字类型；输入文本框的边框宽度；默认：0
        },
        dividingLine: { //（可选项）JSON对象；按钮与输入框之间的分割线的配置
            width: 0.5, //（可选项）数字类型；分割线粗细；默认：0.5
            color: '#fff' //（可选项）字符串类型；分割线颜色，支持rgb、rgba、#；默认：#696969
        },
        left: { //（可选项）JSON 对象；左边按钮样式配置，不传则不显示左边按钮
            bg: '#fff', //（可选项）字符串类型；左边按钮的背景，支持rgb、rgba、#、img；默认：'rgba(0,0,0,0)'
            color: '#999999', //（可选项）字符串类型；左边按钮标题字体颜色，支持rgb，rgba、#；默认：'#007FFF'
            size: 15,
            corner: 5, //（可选项）数字类型；左边按钮标题字体大小；默认：12
            h: 50 //(可选项) 数字类型；左边按钮的高度；默认：40
        },
        right: { //（可选项）JSON 对象；右边按钮样式配置，不传则不显示右边按钮
            bg: '#fff', //（可选项）字符串类型；右边按钮标题字体颜色，支持rgb、rgba、#；默认：'#007FFF'
            size: 15,
            corner: 5,
            color: '#E4393C', //（可选项）数字类型；右边按钮标题字体大小；默认：12
            h: 50 //(可选项) 数字类型；右边按钮的高度；默认：40
        },
        horizontalLine: {
            color: '#dcdcdc',
            height: 1
        },
        verticalLine: {
            color: '#dcdcdc',
            width: 1
        }
    }
    /*--------------------------------弹窗样式配置结束----------------------------*/

/*--------------------------------loading动画配置开始-----------------------*/
var frames = [{
    "frame": "widget://image/loading/0.png"
}, {
    "frame": "widget://image/loading/1.png"
}, {
    "frame": "widget://image/loading/2.png"
}, {
    "frame": "widget://image/loading/3.png"
}, {
    "frame": "widget://image/loading/4.png"
}, {
    "frame": "widget://image/loading/5.png"
}, {
    "frame": "widget://image/loading/6.png"
}, {
    "frame": "widget://image/loading/7.png"
}, {
    "frame": "widget://image/loading/8.png"
}, {
    "frame": "widget://image/loading/9.png"
}, {
    "frame": "widget://image/loading/10.png"
}, {
    "frame": "widget://image/loading/11.png"
}, {
    "frame": "widget://image/loading/12.png"
}, {
    "frame": "widget://image/loading/13.png"
}, {
    "frame": "widget://image/loading/14.png"
}, {
    "frame": "widget://image/loading/15.png"
}, {
    "frame": "widget://image/loading/16.png"
}, {
    "frame": "widget://image/loading/17.png"
}, {
    "frame": "widget://image/loading/18.png"
}, {
    "frame": "widget://image/loading/19.png"
}, {
    "frame": "widget://image/loading/20.png"
}, ];
var loadingConfig = {
    rect: {
        w: 80,
        h: 80
    },
    styles: {
        bg: 'rgba(0,0,0,0.6)',
        corner: 5,
        interval: 50,
        frame: {
            w: 65,
            h: 65
        }
    },
    content: frames
};
/*--------------------------------loading动画配置结束-----------------------*/
/*--------------------------------聊天输入面板配置开始-----------------------*/
var chatInputConfig = {
    maxRows: 4,
    emotionPath: 'widget://res/img/emotion',
    texts: {
        recordBtn: {
            normalTitle: '按住 说话',
            activeTitle: '松开 结束'
        },
        sendBtn: {
            title: '发送'
        }
    },
    styles: {
        topDivider: {
            width: 1,
            color: '#dcdcdc'
        },
        inputBar: {
            borderColor: '#dcdcdc',
            bgColor: '#f4f4f4'
        },
        inputBox: {
            borderColor: '#d4d4d4',
            bgColor: '#FFFFFF'
        },
        emotionBtn: {
            normalImg: 'widget://res/img/face1.png'
        },
        extrasBtn: {
            normalImg: 'widget://res/img/add1.png'
        },
        keyboardBtn: {
            normalImg: 'widget://res/img/key1.png'
        },
        speechBtn: {
            normalImg: 'widget://res/img/record.png'
        },
        recordBtn: {
            normalBg: '#f4f4f4',
            activeBg: '#c4c4c4',
            color: '#999',
            size: 14
        },
        indicator: {
            target: 'both',
            color: '#c4c4c4',
            activeColor: '#9e9e9e'
        },
        sendBtn: {
            titleColor: '#fff',
            bg: '#49b152',
            activeBg: '#49b152',
            titleSize: 14
        }
    },
    extras: {
        titleSize: 10,
        titleColor: '#a3a3a3',
        btns: [{
            title: '图片',
            normalImg: 'widget://res/img/album1.png',
            activeImg: 'widget://res/img/album2.png'
        }, {
            title: '拍照',
            normalImg: 'widget://res/img/cam1.png',
            activeImg: 'widget://res/img/cam1.png'
        }]
    }
};
/*--------------------------------聊天输入面板配置结束-----------------------*/

/*--------------------------------refresh动画配置开始-----------------------*/
var refresh = {
    bgColor: '#c91d1d',
    refreshHeaderHeight: 60,
    loadAnimInterval: 100,
    image: {
        pull: [
            'widget://image/refresh/0.png',
            'widget://image/refresh/1.png',
            'widget://image/refresh/2.png',
            'widget://image/refresh/3.png',
            'widget://image/refresh/4.png',
            'widget://image/refresh/5.png',
            'widget://image/refresh/6.png',
            'widget://image/refresh/7.png',
            'widget://image/refresh/8.png',
            'widget://image/refresh/9.png',
            'widget://image/refresh/10.png',
            'widget://image/refresh/11.png',
            'widget://image/refresh/12.png',
            'widget://image/refresh/13.png',
            'widget://image/refresh/14.png',
            'widget://image/refresh/15.png',
            'widget://image/refresh/16.png',
            'widget://image/refresh/17.png'
        ],
        load: [
            'widget://image/refresh/0.png',
            'widget://image/refresh/1.png',
            'widget://image/refresh/2.png',
            'widget://image/refresh/3.png',
            'widget://image/refresh/4.png',
            'widget://image/refresh/5.png',
            'widget://image/refresh/6.png',
            'widget://image/refresh/7.png',
            'widget://image/refresh/8.png',
            'widget://image/refresh/9.png',
            'widget://image/refresh/10.png',
            'widget://image/refresh/11.png',
            'widget://image/refresh/12.png',
            'widget://image/refresh/13.png',
            'widget://image/refresh/14.png',
            'widget://image/refresh/15.png',
            'widget://image/refresh/16.png',
            'widget://image/refresh/17.png',
            'widget://image/refresh/18.png',
            'widget://image/refresh/19.png',
            'widget://image/refresh/20.png',
            'widget://image/refresh/21.png',
            'widget://image/refresh/22.png',
            'widget://image/refresh/23.png',
            'widget://image/refresh/24.png',
            'widget://image/refresh/25.png',
            'widget://image/refresh/26.png',
            'widget://image/refresh/27.png',
            'widget://image/refresh/28.png',
            'widget://image/refresh/29.png',
            'widget://image/refresh/30.png',
            'widget://image/refresh/31.png',
            'widget://image/refresh/32.png',
            'widget://image/refresh/33.png',
            'widget://image/refresh/34.png',
        ]
    },
    isScale: false
};
/*--------------------------------refresh动画配置结束-----------------------*/

/*----------------------vue全局异常捕获器---------------------------------*/
// Vue.config.errorHandler = function(err, vm, info) {
//     console.log(err);
//     console.log(vm);
//     console.log(info);
// };

/*-----------------------vue全局过滤器------------------------------------*/
if (window.Vue) {
    Vue.filter('toFixed', function(value, mantissa) {
        if (!mantissa && mantissa != 0) {
          mantissa = 0;
        }
        return !value ? 0.00 : parseFloat(value).toFixed(mantissa);
    });
    Vue.filter('replaceTextarea', function(value) {
        if (!value) {
            return value;
        }
        return value.replace(/textarea/g, 'div');
    });
}

/*------------------------vue全局组件------------------------------------*/
// Vue.component('button-counter', {
//     data: function() {
//         return {
//             count: 0
//         }
//     },
//     template: '<span v-on:click="count++" class="aui-btn aui-btn-primary">You clicked me {{ count }} times.</span>'
// });

// 分享弹窗配置
var shareConfig = {
    rect: {
        h: 200
    },
    texts: {
        cancel: '取消'
    },
    items: [{
        text: '生成海报',
        icon: 'widget://image/icon/icon_hb.png'
    }, {
        text: '微信好友',
        icon: 'widget://image/icon/icon_wx.png'
    }, {
        text: '朋友圈',
        icon: 'widget://image/icon/icon_pyq.png'
    }, {
        text: 'QQ好友',
        icon: 'widget://image/icon/icon_qq.png'
    }, {
        text: 'QQ空间',
        icon: 'widget://image/icon/icon_kj.png'
    }, {
        text: '新浪微博',
        icon: 'widget://image/icon/icon_sina.png'
    }],
    styles: {
        bg: '#FFF',
        corner: 10,
        column: 4,
        itemText: {
            color: '#000',
            size: 15,
            marginT: 8
        },
        itemIcon: {
            size: 50
        },
        cancel: {
            color: '#000',
            h: 44,
            size: 14
        }
    },
    tapClose: true
};

var commentInputConfig = {
    placeholder: '你的想法...',
    maxRows: 4,
    texts: {
        sendBtn: {
            title: '确定'
        }
    },
    styles: {
        topDivider: {
            width: 0,
            color: '#f8f8f8'
        },
        inputBar: {
            borderColor: '#f8f8f8',
            bgColor: '#f8f8f8'
        },
        inputBox: {
            borderColor: '#f8f8f8',
            bgColor: '#FFFFFF'
        },
        sendBtn: {
            titleColor: '#333',
            bg: 'rgba(0,0,0,0)',
            activeBg: 'rgba(0,0,0,0)',
            titleSize: 14
        }
    }
};

function dbClickExitApp() {
    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        $k.toast('再按一次返回键退出应用');
        api.addEventListener({
            name: 'keyback'
        }, function(ret, err) {
            api.closeWidget({
                id: 'A6090419744462',
                retData: {
                    name: 'closeWidget'
                },
                silent: true
            });
        });
        setTimeout(function() {
            dbClickExitApp();
        }, 3000)
    });
}

/*--------------------------------封装工具方法----------------------------*/
(function(window) {
    var k = {};
    // 长按
    var el = null,
        timer = null,
        duration = 1000,
        callbackFunc = void(0);
    // k = function (selector) {
    //     el = selector;
    //     console.log(12);
    //     return k;
    // };
    k.addLongPressEventListener = function(el, callbackFunction) {
        if (!el) {
            return;
        }
        var _this = this;
        callbackFunc = callbackFunction;
        var els = window.document.querySelectorAll(el);
        var pd = function(event) {
            _this.pressDown(event);
        };
        for (var i = 0; i < els.length; i++) {
            els[i].addEventListener('touchstart', pd);
            els[i].addEventListener('touchmove', _this.pressUp);
            els[i].addEventListener('touchend', _this.pressUp);
        }
    };
    k.pressDown = function(event) {
        var that = this;
        timer = setTimeout(function() {
            window.clearTimeout(timer);
            that.callback(event);
        }, 1000);
    };
    k.pressUp = function() {
        window.clearTimeout(timer);
    };
    k.callback = function(event) {
        callbackFunc(event);
    };
    // 长按end

    k.serializeForm = function(formId) {
        var form = document.getElementById(formId);
        var arr = {};
        for (var i = 0; i < form.elements.length; i++) {
            var feled = form.elements[i];
            switch (feled.type) {
                case undefined:
                case 'button':
                case 'file':
                case 'reset':
                case 'submit':
                    break;
                case 'checkbox':
                case 'radio':
                    if (!feled.checked) {
                        break;
                    }
                default:
                    if (arr[feled.name]) {
                        arr[feled.name] = arr[feled.name] + ',' + feled.value;
                    } else {
                        arr[feled.name] = feled.value;
                    }
            }
        }
        return arr;
    };
    k.getLoginUser = function() {
        var user = api.getPrefs({
            sync: true,
            key: "user"
        });
        return (!user || user == "") ? null : JSON.parse(user);
    };
    k.setLoginUser = function(user) {
        api.setPrefs({
            key: "user",
            value: JSON.stringify(user)
        });
    };
    k.delLoginUser = function() {
        api.removePrefs({
            key: "user"
        });
    };
    k.setValue = function(key, value) {
        api.setPrefs({
            key: key,
            value: value.toString()
        });
    };
    k.setValueJson = function(key, value) {
        api.setPrefs({
            key: key,
            value: JSON.stringify(value)
        });
    };
    k.sendEvent = function(name, extra) {
        api.sendEvent({
            name: name,
            extra: extra
        })
    };
    k.addEventListener = function(name, callback) {
        api.addEventListener({
            name: name
        }, function(ret, err) {
            callback(ret, err)
        });
    };
    k.getValue = function(key) {
        var value = api.getPrefs({
            sync: true,
            key: key
        });
        return value;
    };
    k.openWin = function(name, uri, params, isBounces, isReload) {
        if (!name || !uri || name == '' || uri == '') {
            return;
        }
        isBounces = isBounces ? isBounces : false;
        isReload = isReload ? isReload : false;
        api.openWin({
            name: name,
            url: 'widget://html/' + uri + '.html',
            pageParam: params,
            bounces: isBounces,
            reload: isReload
        });
    };
    k.openWinAnimation = function(name, uri, params, isBounces, isReload){
      if (!name || !uri || name == '' || uri == '') {
          return;
      }
      isBounces = isBounces ? isBounces : false;
      isReload = isReload ? isReload : false;
      api.openWin({
          name: name,
          url: 'widget://html/' + uri + '.html',
          pageParam: params,
          bounces: isBounces,
          reload: isReload,
          animation:{
            type: 'fade',
            subType: 'from_bottom'
          }
      });
    };
    k.closeWin = function(winNames) {
        var names = winNames.split(',');
        setTimeout(function() {
            for (var i = 0; i < names.length; i++) {
                api.closeWin({
                    name: names[i]
                });
            }
        }, 500);
    };
    //不支持IOS右滑返回上一页打开方式
    k.openWinSlidBackEnabled = function(name, uri, params, isBounces, isReload) {
        if (!name || !uri || name == '' || uri == '') {
            return;
        }
        isBounces = isBounces ? isBounces : false;
        isReload = isReload ? isReload : false;
        api.openWin({
            name: name,
            url: 'widget://html/' + uri + '.html',
            pageParam: params,
            bounces: isBounces,
            slidBackEnabled: false,
            reload: isReload,
        });
    };
    k.openFrame = function(name, uri, params, top, right, bottom, left, isBounces, isReload) {
        if (!name || !uri || name == '' || uri == '') {
            return;
        }
        top = top ? top : 0;
        right = right ? right : 0;
        bottom = bottom ? bottom : 0;
        left = left ? left : 0;
        isBounces = isBounces ? isBounces : false;
        isReload = isReload ? isReload : false;
        api.openFrame({
            name: name,
            url: 'widget://html/' + uri + '.html',
            rect: {
                marginTop: top,
                marginBottom: bottom,
                marginLeft: left,
                marginRight: right,
                w: 'auto'
            },
            bounces: isBounces,
            pageParam: params,
            reload: isReload,
            allowEdit: true
        });
    };
    k.isMobile = function(mobile) {
        var reg = /^[1][3,4,5,7,8,9][0-9]{9}$/;
        return reg.test(mobile);
    };
    k.isEmail = function(email) {
        var reg = new RegExp("^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$");
        return reg.test(email);
    };
    k.isEmpty = function(text) {
        return !text || text.toString().trim() === ''
    }
    k.toast = function(msg, location) {
        if (!msg || msg.toString().trim() === '') {
            return;
        }
        api.toast({
            msg: msg,
            duration: 2000,
            location: location
        });
    };
    k.checkResponse = function(ret, reExcuteFunc) {
        var result = false;
        if (ret && ret.code === 200) { //成功
            result = true;
        } else if (ret.code === 201) { //刷新token
            this.setValue('token', 'Bearer {"access_token":"'+ret.data.access_token+'","refresh_token":"'+ret.data.refresh_token+'"}');
            if (reExcuteFunc) { //需要重新请求
                reExcuteFunc();
            }
        } else if (ret.code === 302) { //重新登录
            this.toast('您的登录信息已失效，请重新登录！');
            setTimeout(function() {
                this.delLoginUser();
                this.openWin('login', 'user/login_win');
            }, 2000);
        } else if (ret.code === 500) { //失败
            this.toast(ret.data ? ret.data : '数据加载失败，请稍后重试！');
        } else {
            this.toast(ret.msg);
        }
        return result;
    };
    k.getApiUrl = function(name) {
        if (!name || name == '') {
            return '';
        }
        return URL + URLS[name];
    };
    // 确认框
    k.alert = function(content, buttonText, callback) {
      if (!buttonText) {
        buttonText = '确定';
      }
        dialogBox.alert({
            texts: {
                content: content,
                leftBtnTitle: buttonText,
            },
            styles: alertStyle
        }, function(ret) {
            dialogBox.close({
                dialogName: 'alert'
            });
            if (callback) {
                callback()
            }

        });
    };
    // 确认和取消框
    k.confirm = function(content, callback, leftButtonText, rightButtonText) {
        if (!leftButtonText) {
          leftButtonText = '取消';
        }
        if (!rightButtonText) {
          rightButtonText = '确定';
        }
        dialogBox.alert({
            texts: {
                content: content,
                leftBtnTitle: leftButtonText,
                rightBtnTitle: rightButtonText
            },
            styles: confirmStyle
        }, function(ret) {
            dialogBox.close({
                dialogName: 'alert'
            });
            if (ret.eventType == 'right') {
                callback && callback();
            }
        });
    };
    k.input = function(keyboard, title, placeholder, leftBtnTitle, rightBtnTitle, callback) {
        keyboard = keyboard ? keyboard : 'default';
        title = title ? title : '';
        placeholder = placeholder ? placeholder : '';
        leftBtnTitle = leftBtnTitle ? leftBtnTitle : '';
        rightBtnTitle = rightBtnTitle ? rightBtnTitle : '';
        dialogBox.input({
            keyboardType: 'default',
            texts: {
                title: title,
                placeholder: placeholder,
                leftBtnTitle: leftBtnTitle,
                rightBtnTitle: rightBtnTitle
            },
            styles: inputStyle
        }, function(ret) {
            dialogBox.close({
                dialogName: 'alert'
            });
            if (ret.eventType == 'right') {
                callback && callback(ret)
            }
        })
    };
    // 图片预览
    k.openBrowser = function(img) {
        photoBrowser.open({
            images: [
                img
            ],
            bgColor: '#000'
        }, function(ret, err) {
            if (ret) {
                if (ret.eventType == 'click') {
                    photoBrowser.close()
                }
            } else {

            }
        });
    };
    k.previewPhotos = function(imgs, index) {
        photoBrowser.open({
            images: imgs,
            activeIndex: (!index && index != 0) ? 0 : index ,
            placeholderImg: 'widget://image/loading_more.gif',
            bgColor: '#000'
        }, function(ret, err) {
            if (ret) {
                if (ret.eventType == 'click') {
                    photoBrowser.close()
                }
            } else {

            }
        });
    };
    k.actionSheetFourth = function(data, col, row, callback, active, title, cancelText, okText) {
      title = title ? title : '';
      cancelText = cancelText ? cancelText : '取消';
      okText = okText ? okText : '完成';
        fourStageLinkage.open({
            datas: data,
            layout: {
                row: row,
                col: col,
                height: 45,
                size: 15,
                sizeActive: 16,
                rowSpacing: 5,
                colSpacing: 10,
                maskBg: 'rgba(0,0,0,0.2)',
                bg: '#fff',
                color: '#999',
                colorActive: '#333',
                colorSelected: '#333'
            },
            actives: active,
            animation: true,
            cancel: {
                text: cancelText,
                size: 15,
                w: 90,
                h: 35,
                bg: 'rgba(0,0,0,0)',
                bgActive: 'rgba(0,0,0,0)',
                color: '#2676DC',
                colorActive: '#fff'
            },
            ok: {
                text: okText,
                size: 15,
                w: 90,
                h: 35,
                bg: 'rgba(0,0,0,0)',
                bgActive: 'rgba(0,0,0,0)',
                color: '#2676DC',
                colorActive: '#fff'
            },
            title: {
                text: title,
                size: 15,
                h: 44,
                bg: '#f4f4f4',
                color: '#333333'
            },
            fixedOn: api.frameName
        }, function(ret, err) {
            if (ret && ret.eventType == 'ok') {
                callback(ret, err)
            }
        });
    };
    k.cloneObject = function(obj) {
        var newObj = {};
        for (var key in obj) {
            newObj[key] = obj[key];
        }
        return newObj;
    };
    k.getShareImage = function(url, callback) {
        var result = 'widget://image/logo.png';
        if (!url) {
            callback(result);
            return;
        }
        api.download({
            url: url,
        }, function(ret, err) {
            if (ret.state == 1) {
                result = ret.savePath;
            }
            callback(result);
        });
    };
    k.generateImage = function(data, path, name, callback) {
        var _this = this;
        _this.fileExist(path + name, function(exist) {
            if (exist) {
                callback();
            } else {
                var trans = api.require('trans');
                data = data.replace('data:image/png;base64,', '');
                trans.saveImage({
                    base64Str: data,
                    imgPath: path,
                    imgName: name
                }, function(ret, err) {
                    if (ret.status) {
                        callback();
                    } else {
                        _this.toast('海报生成失败，请重试');
                    }
                });
            }
        });
    };
    k.compressImage = function(path, name, callback) {
        this.fileExist(path + 'thumb_' + name, function(exist) {
            if (exist) {
                callback();
            } else {
                var imageFilter = api.require('imageFilter');
                imageFilter.compress({
                    img: path + name,
                    quality: 1,
                    scale: 0.25,
                    save: {
                        imgPath: path,
                        imgName: 'thumb_' + name
                    }
                }, function(ret, err) {
                    if (ret.status) {
                        callback();
                    }
                });
            }
        });
    };
    k.fileExist = function(file, callback) {
        var fs = api.require('fs');
        fs.exist({
            path: file
        }, function(ret, err) {
            if (ret.exist) {
                callback(true);
            } else {
                callback(false);
            }
        });
    };
    k.saveImage = function(data, name, callback) {
        var trans = api.require('trans');
        var _this = this;
        data = data.replace('data:image/png;base64,', '');
        trans.saveImage({
            base64Str: data,
            album: true,
            imgPath: 'fs://poster/',
            imgName: name + '.png'
        }, function(ret, err) {
            if (ret.status) {
                _this.toast('图片已保存到手机相册');
                callback();
            } else {
                _this.toast('保存失败，请重试');
            }
        });
    };
    k.downloadQrcode = function(url, callback) {
        var _this = this;
        api.download({
            url: url,
        }, function(ret, err) {
            if (ret.state == 1) {
                result = ret.savePath;
                api.saveMediaToAlbum({
                    path: ret.savePath
                }, function(ret, err) {
                    if (ret && ret.status) {
                        _this.toast('图片已保存到手机相册');
                        callback();
                    } else {
                        _this.toast('保存失败，请重试');
                    }
                });
            }
        });
    };
    k.multiSelector = function(type,max,callback){
      UIAlbumBrowser.open({
          max: max,
          type: type,
          styles: {
              bg: '#fff',
              mark: {
                  position: 'top_right',
                  size: 20
              },
              nav: {
                  bg: '#7E1A27',
                  titleColor: '#fff',
                  titleSize: 18,
                  cancelColor: '#fff',
                  cancelSize: 16,
                  finishColor: '#fff',
                  finishSize: 16
              }
          },
          rotation: false
      }, function(ret) {
          if (ret && ret.eventType == 'confirm') {
              // 转换已选中图片地址
              var list = ret.list,images = [];
              for (var i = 0; i < list.length; i++) {
                images.push(list[i].path);
              }
              UIAlbumBrowser.batchTransPath({
                path: images
              },function(ret,err){
                callback && callback(ret.path);
              });
          }
      });
    };
    // 请求权限
    k.reqPermissions = function(permissions,callback){
      api.requestPermission({
        list: permissions,
        code: 100001
      },function(ret, err){
        if(callback){
          callback && callback(ret);
        }
      });
    };
    // 检查权限
    k.checkPermissions = function(permissions,callback){
      var rets = api.hasPermission({
        list:permissions
      });
      // 将未拥有的权限进行授权提示
      var list = [];
      for (var i = 0; i < rets.length; i++) {
        if (!rets[i].granted) {
          list.push(rets[i].name);
        }
      }
      if (list.length > 0) {
        this.reqPermissions(list);
      }
    };
    k.sendLoginEvent = function(){
      // 初始化IM客户端和推送客户端
      this.sendEvent(eventName.loginEvent);
      // 刷新个人中心
      this.sendEvent(eventName.refreshUserCenter);
      // 刷新未读消息数量
      this.sendEvent(eventName.reloadAddFriendListCount);
    };
    k.sendLogoutEvent = function(){
      // 初始化IM客户端和推送客户端
      this.sendEvent(eventName.logoutEvent);
      // 刷新个人中心
      this.sendEvent(eventName.refreshUserCenter);
      // 刷新未读消息数量
      this.sendEvent(eventName.reloadAddFriendListCount);
    };
    k._get = function(action, params, callback){
      api.ajax({
          url: this.getApiUrl(action),
          method: 'get',
          data: {
              values: params,
          }
      },function(ret, err){
          if (this.checkResponse(ret)) {

          }
      });
    };
    window.$k = k;
})(window);
